﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApplication6
{
  /// <summary>
  /// Logique d'interaction pour Window1.xaml
  /// </summary>
  ///

  public partial class Window1 : Window
  {
    List<Book> LsBooks;

    public Window1()
    {
      InitializeComponent();
    }

    private void Window_Loaded(object sender, RoutedEventArgs e)
    {
      // initialisation collection qui sert de source au datagrid
      LsBooks = new List<Book>();
      LsBooks.Add(new Book(30, "j'ai les cheveux longs", "napoleon"));
      LsBooks.Add(new Book(30, "le bon gigot d'antan", "maite"));
      LsBooks.Add(new Book(30, "oui oui et sa voiture jaune", "non non"));
      
      dataGrid1.ItemsSource = LsBooks;

    }

    /* rafraichissement en réinitialisant la propriété itemsource du datagrid
     * fonctionne mais gros inconvénient de cette méthode : si l'utilisateur a changé l'ordre des colonnes ou fait un tri particulier ou autres, c'est perdu (le tri, l'ordonnancement)
     */
    private void button1_Click(object sender, RoutedEventArgs e)
    {
      // modification de la source
      LsBooks[0].price += 1;
      LsBooks.Add(new Book(30, "C'est du béton", "Tony Glandil"));

      // actualisation
      dataGrid1.ItemsSource = null;
      dataGrid1.ItemsSource = LsBooks;
    }

    /* note sur le refraichissement par binding, si on enlève le "dataGrid1.ItemsSource = LsBooks;" de l'evenement loaded et que l'on execute le projet, puis clique sur le bouton "refresh normal", on voit bien que le binding se fait puisque la datagrid se remplit. 
     * mais s'il y a déjà quelquechose dans la grille, rien ne se passe
     */
    private void button2_Click(object sender, RoutedEventArgs e)
    {

      // modification de la source
      LsBooks[1].price += 1;
      LsBooks.Add(new Book(20, "Comment rater un tour hihihi", "Garcimore"));

      // mise en place du binding (serait mieux dans l'evenement loaded mais histoire de tout séparer, je le mets ici)
      Binding b = new Binding("");
      b.Mode = BindingMode.OneWay;
      b.Source = LsBooks;
      dataGrid1.SetBinding(ItemsControl.ItemsSourceProperty, b);
      

      // création d'un bindingexpression pour lancer le binding quand on veut 
      BindingExpression bindExpression = dataGrid1.GetBindingExpression(ItemsControl.ItemsSourceProperty);

      // on mets à jour
      bindExpression.UpdateTarget();

      // perdu , ça ne fait rien ... pourquoi ? 
    }
  }


  public class Book
  {
    public int price { get;  set; }
    public string title { get;  set; }
    public string author { get;  set; }

    public Book(int p, string t, string a)
    {
      price = p;
      title = t;
      author = a;
    }
  }
}
